/***** revComp.c **********************************
 * Description: 
 * Author: Bernhard Haubold, haubold@evolbio.mpg.de
 * Date: Tue Jan  6 16:32:34 2015
 **************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "sequenceData.h"
#include "stringUtil.h"
#include "interface.h"
#include "eprintf.h"

#define LINELENGTH 70

void scanFile(FILE *fp, Args *args);

int main(int argc, char *argv[]){
  int i;
  char *version;
  Args *args;
  FILE *fp;

  version = "1.6";
  setprogname2("revComp");
  args = getArgs(argc, argv);
  if(args->v)
    printSplash(version);
  if(args->h || args->e)
    printUsage(version);
  if(args->numInputFiles == 0){
    fp = stdin;
    scanFile(fp, args);
  }else{
    for(i=0;i<args->numInputFiles;i++){
      fp = efopen(args->inputFiles[i],"r");
      scanFile(fp, args);
      fclose(fp);
    }
  }
  free(args);
  free(progname());
  return 0;
}

void scanFile(FILE *fp, Args *args){
  Sequence *seq;
  int i, c, residues;

  seq = NULL;
  while((seq = getNextSequence(fp)) != NULL){
    if(args->r)
      rev(seq->seq);
    if(args->c)
      comp(seq->seq);
    if(!(args->r || args->c))
      revcomp(seq->seq);
    c = 0;
    i = 0;
    residues = strlen(seq->seq);
    printf("%s - ",chomp(seq->id));
    if(args->r)
      printf("REVERSE");
    if(args->c)
      printf("COMPLEMENT");
    if(!(args->c || args->r))
       printf("REVERSECOMPLEMENT");
    printf("\n");
    while(i < residues){
      if(c == LINELENGTH){
	printf("\n");
	c = 0;
      }
      printf("%c",seq->seq[i]);
      i++;
      c++;
    }
    printf("\n");
    freeSequence(seq);
  }
}
